Débuter avec les scripts

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page FreeCAD Scripting Basics and the translation is 100% complete.

Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎Bahasa Indonesia • ‎italiano • ‎polski • ‎português • ‎română • ‎русский • ‎svenska • ‎Türkçe • ‎中文(中国大陆)‎
Arrow-left.svg Page précédente: Python script tutoriel
Page suivante: Scripts pour Mesh Arrow-right.svg

Python scripting in FreeCAD

FreeCAD a été programmé dès la première ligne de code dans le but d'être totalement contrôlé par des scripts écrits en Python. Presque toutes les procédures de FreeCAD, telles que l'interface, le contenu des scènes, même la représentation du contenu des vues 3D, sont accessibles à partir de l'interpréteur Python ou de vos propres scripts.
Par conséquence, FreeCAD est probablement l'une des applications d'ingénierie la plus profondément personnalisable et évolutive disponible actuellement.

Dans son état actuel, FreeCAD a très peu de commandes de base pour interagir avec vos objets 3D, FreeCAD est encore jeune et est encore au stade de développement, de plus, la philosophie du développement de FreeCAD est orientée de manière à fournir une plate-forme CAD plutôt qu'une application d'utilisation spécifique.
Grâce aux scripts Python utilisables dans FreeCAD, nous avons un moyen très simple et rapide de voir et de tester les nouvelles fonctionnalités des modules élaborés par la communauté internationale des utilisateurs, des utilisateurs qui, généralement connaissent la programmation Python.
Python est l'un des langages interprétés les plus populaires et, généralement considéré comme très facile à apprendre, bientôt, vous pourrez aussi écrire vos scripts pour modeler "votre propre" FreeCAD.

Si vous n'êtes pas familier avec Python, nous vous recommandons de chercher des tutoriels sur internet et "jeter un œil rapide" sur sa structure. Python est un langage très facile à apprendre, en particulier parce qu'il peut être exécuté à l'intérieur de l'interpréteur, de la plus simple commande jusqu'à l'élaboration de programmes complexes, il peut être exécuté à la volée sans avoir besoin de compilateur. FreeCAD dispose de son propre interpréteur Python intégré. Si vous ne voyez pas de fenêtre intitulée Console Python comme illustré ci-dessous, vous pouvez l'activer en cliquant dans la barre d'outils Affichage → Vues → Console Python pour afficher l’interpréteur Python.

L'interpréteur Python

A partir de l’interpréteur Python, vous pouvez accéder à l'ensemble des modules Python installés, les modules originaux de FreeCAD, ainsi que tous les modules supplémentaires que vous installerez plus tard dans FreeCAD. La capture d'écran ci-dessous vous montre l'interpréteur Python:

The FreeCAD Python interpreter

A partir de l’interpréteur, vous pouvez exécuter du code Python et naviguer à travers les classes et fonctions disponibles. FreeCAD fournit un navigateur de classe très pratique pour l'exploration de votre nouvel univers qu'est FreeCAD. Lorsque vous tapez le nom d'une classe connue suivie d'un "." (point) (ce qui veut dire que vous voulez ajouter quelque chose après le point à partir de cette classe), une fenêtre s'ouvre et vous renseigne sur les options et méthodes disponibles dans cette classe. Lorsque vous sélectionnez une option, le texte d'aide qui lui est associé (s'il est disponible) est automatiquement affiché:

The FreeCAD class browser

Alors, commencez ici en tapant App. ou Gui. (Attention à la casse App est différent de app) et regardez ce qui se passe.
Une autre façon plus simple d'explorer Python le contenu des modules et des classes est d'utiliser la commande d'affichage dir().
Par exemple, en tapant dir() tous les modules actuellements répertoriés et chargés dans FreeCAD s'affichent.Si vous tapez dir(App) tout ce qu'il y a à l'intérieur du module App sera affiché , etc.

Une autre caractéristique utile de l'interprèteur est la possibilité de revenir en arrière dans l'historique des commandes et récupérer une ligne de code que vous avez tapé plus tôt. Pour naviguer dans l'historique des commandes, il suffit d'utiliser CTRL + HAUT ou CTRL + BAS.

Si vous cliquez avec le bouton droit de la souris dans la fenêtre de l'interpréteur, vous avez également les options classiques d'un traitement de texte, telles que copier tout l'histoire (utile lorsque vous voulez expérimenter votre code avant de faire votre script final), ou d'insérer un nom de fichier avec le chemin complet.

Aide Python

Dans le menu Aide de FreeCAD, vous trouverez une entrée portant la mention 'Automatic python modules documentation' qui va ouvrir une fenêtre de navigateur contenant la liste complète de la documentation de l'ensemble des modules Python à disposition de l’interpréteur FreeCAD. Ce sont les modules fournis avec Python et ceux intégrés dans FreeCAD. La documentation disponible dépend de l'effort que le développeur a mis pour documenter le code son module, les modules Python en général, ont la réputation d'être bien documentés. FreeCAD doit rester ouvert pour travailler avec ce système de documentation. L'entrée 'Aide Python' vous donnera un lien rapide vers cette section du wiki "User Hub".

Modules incorporés (Built-in)

FreeCAD étant conçu pour être exécuté sans interface graphique (GUI), la quasi-totalité de ses fonctionnalités est séparé en deux groupes: les fonctionnalités de base, nommés «App», et la fonctionnalité graphique, nommée «Gui». Donc, nos deux principaux modules dans FreeCAD sont appelés App et Gui.
Ces deux modules peuvent également être accessibles à partir des scripts, respectivement avec les noms FreeCAD et FreeCADGui. Ils sont accessibles même hors de l’interpréteur.

  • Dans l'App module, vous trouverez tout ce qui concerne l'application elle-même, comme, les procédures d'ouvrir ou fermeture de fichiers, comme l'ouverture de la feuille active ou lister le contenu de la feuille . . .
  • Dans l'Gui module, vous trouverez des outils pour accéder et gérer les éléments graphiques, comme les boutons utilisateurs et leur barres d'outils, et, plus intéressant, la représentation graphique de l'ensemble du contenu FreeCAD.

Lister tout le contenu de ces modules est un contre-productif, car ils grandissent très vite compte tenu de la progression du développement de FreeCAD.
Mais les deux outils fourni (le navigateur de classe et de l'aide de Python) vous donnerons, à tout moment, une complète documentation mise à jour sur ces modules.

Les objets "App" et "Gui"

Comme nous l'avons dit, dans FreeCAD, tout est séparé entre le noyau et la représentation du projet. Y compris les objets 3D.
Vous pouvez accéder aux propriétés des objets (appelés fonctions dans FreeCAD) via le module App, et modifier la façon dont ils sont représentés sur l'écran via le module de Gui.
Par exemple, un cube possède des propriétés qui le définissent, (comme la largeur, longueur, hauteur) qui sont stockées dans un App objet et, les propriétés de représentation (comme la couleur des faces, le mode de dessin) qui sont stockées dans un objet correspondant Gui.

Cette méthode de travail permet une multitude d'utilisations, comme des algorithmes travaillant uniquement sur la partie caractéristiques, sans avoir à se soucier de la partie visuelle, voire de réorienter le contenu du document à une partie non-graphique de l'application, tels que des listes, des tableurs, ou l'analyse d'éléments.

Pour chaque objet App dans votre document, il existe un objet correspondant Gui.
En fait le document lui-même possède à la fois des objets App et des objets Gui. Bien sûr, ceci n'est valable que lorsque vous exécutez FreeCAD dans son interface graphique. Dans la version en ligne de commande (sans interface graphique), seuls les "objets App" sont accessibles.
Notez que la partie "objet Gui" est réactualisé chaque fois qu'un "objet App" est recalculé (par exemple lorsqu'il y a un changement de paramètres), les changements que vous pourriez avoir fait directement à l'objet Gui peuvent être perdues.

Pour accéder à la partie App d'un objet, vous devez tapez:

myObject = App.ActiveDocument.getObject("ObjectName")

où "ObjectName" est le nom de votre objet.
Le même résultat est obtenu en tapant:

myObject = App.ActiveDocument.ObjectName

Pour accéder à la partie Gui d'un l'objet , vous tapez:

myViewObject = Gui.ActiveDocument.getObject("ObjectName")

où "ObjectName" est le nom de votre objet.
Le même résultat est obtenu en tapant:

myViewObject = App.ActiveDocument.ObjectName.ViewObject

Si vous n'êtes pas dans l'interface graphique (Gui) (par exemple si vous êtes en mode ligne de commande), la dernière ligne retournée sera 'None'.

Les objets dans un document

Dans FreeCAD tout votre travail est dans un "Document". Ce document contient vos formes géométriquee et peut être sauvegardé dans un fichier. Dans FreeCAD, plusieurs documents peuvent être ouverts en même temps. Le document, et les formes géométriques contenues , sont des objets App et des objets Gui. Les objets App contiennent les définitions des formes géométriques réelles, tandis que les objets Gui contiennent les différentes vues de votre document.
Vous pouvez ouvrir plusieurs fenêtres, chacune de ces fenêtres peut afficher votre projet avec un facteur de zoom différent ou des vues différentes du projet. Ces vues font toutes partie de l'objet Gui de votre document.

Pour accéder à la partie App du document ouvert (actif), tapez:

myDocument = App.ActiveDocument

Pour créer un nouveau document, tapez:

myDocument = App.newDocument("Document Name")

Pour accéder à la partie graphique (Gui) du document ouvert (actif), tapez:

myGuiDocument = Gui.ActiveDocument

Pour accéder à la vue courante, tapez:

myView = Gui.ActiveDocument.ActiveView

Modules supplémentaires

Les modules FreeCAD et FreeCADGui sont utilisés uniquement pour créer et gérer des objets dans le document FreeCAD. Ils ne sont pas utilisés pour la création ou la modification des formes géométriques.
Les formes géométriques peuvent être de plusieurs types, elles sont donc construites par des modules supplémentaires, chaque module s'occupe la gestion d'un type de forme géométrique spécifique.
Par exemple, le module "Part utilisé par le noyau OpenCascade, et donc capable de créer et manipuler des formes géométriques de type B-rep, pour lequel OpenCascade est construit.
Le module "Mesh" est capable de construire et modifier des objets Mesh (mailles). De cette façon, FreeCAD est capable de gérer une grande variété de types d'objets, qui peuvent coexister dans le même document, et de nouveaux types d'objets pourront êtres ajoutés facilement et constamment.

Création d'objets

Chaque module a sa propre manière de gérer sa forme géométrique, mais il y a une chose qu'ils peuvent tous faire, c'est de créer des objets dans le document.
Mais, le document FreeCAD connaît tous les types d'objets disponibles fournis par les modules,
tapez:

FreeCAD.ActiveDocument.supportedTypes()

FreeCAD listera tous les objets possibles que vous pouvez créer.
Par exemple, nous allons créer un objet maillage (traité par le module "Mesh") et une objet Part (traité par le module le "Part"):

myMesh = FreeCAD.ActiveDocument.addObject("Mesh::Feature","myMeshName")
myPart = FreeCAD.ActiveDocument.addObject("Part::Feature","myPartName")

Le premier argument est le type d'objet "Mesh::", le second est le nom de l'objet "myMeshName". Nos deux objets semblent identiques: Ils ne contiennent pas encore de forme géométrique, et la plupart de leurs propriétés sont les mêmes lorsque vous les inspecter avec dir(myMesh) et dir(myPart).
Sauf que, myMesh a une propriété "Mesh" (maille) et myPart a une propriété "Part" (forme géométrique).
C'est de cette manière que les données de "Mesh" (maillage) et "Part" (forme géométrique) sont stockées.
Par exemple, nous allons créer un cube (Part) et le stocker dans notre objet myPart:

import Part
cube = Part.makeBox(2,2,2)
myPart.Shape = cube

Si vous essayez de stocker le cube avec la propriété objet Mesh "myMesh", il retournera une erreur de type. Car ces propriétés sont conçues uniquement pour stocker un type d'objet bien défini.
Dans la propriété objet Mesh "myMesh", vous ne pouvez enregistrer que des objets créé avec le module Mesh.
Notez que la plupart des modules disposent également d'un raccourci pour ajouter leur formes géométriques au document:

import Part
cube = Part.makeBox(2,2,2)
Part.show(cube)

Modification d'objets

La modification d'un objet est faite de la même manière:

import Part
cube = Part.makeBox(2,2,2)
myPart.Shape = cube

Maintenant, nous allons construire un cube plus gros:

biggercube = Part.makeBox(5,5,5)
myPart.Shape = biggercube

Questionner les objets

Vous pouvez toujours connaître de quel type est un objet.
Faites ceci:

myObj = FreeCAD.ActiveDocument.getObject("myObjectName")
print myObj.TypeId

ou de savoir si un objet fait partie d'un modèle de base (Part Feature, Mesh Feature, etc):

print myObj.isDerivedFrom("Part::Feature")

Maintenant vous pouvez commencer à travailler avec FreeCAD! Pour savoir ce que vous pouvez faire avec le Part Module, lisez la page Part scripting, ou la page Script Mesh pour travailler avec le module Mesh .
Notez que, bien que les modules Part et Mesh sont les plus complets et les plus largement utilisés, les autres modules tels que le Draft Module (Projet) ont également leurs API scripts qui peuvent vous être utiles.
Pour une liste complète de chaque module et de leurs outils disponibles, visitez la section :Category:API (en).

Arrow-left.svg Page précédente: Python script tutoriel
Page suivante: Scripts pour Mesh Arrow-right.svg